;##################################################################
; DIALOGAPP
;##################################################################

#include "IDExplore.h"

DEBUGLIB equ \Programming\RadASM\GoAsm\lib\Debug.lib
DEBUGEXE equ "\Programming\RadAsm\GoAsm\lib\dbgwin.exe"

#include "\Programming\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 // use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 // setting this to 1 will suppress PrintError if no error exists 

DATA SECTION
	hInstance DD ?
	IID_IVSHelp80 GUID GUID_IID_IVSHelp80
	Collection DB "ms-help://MS.MSDNQTR.v90.en",0
	Keyword DB "CoInitialize",0
	wszNULL	DB	L"",0
	pDExplore DD ?
	hDExplore DD ?

CODE SECTION

Start:
	invoke CoInitialize,NULL
	invoke GetInterface,offset pDExplore,"DExplore.AppObj",offset IID_IVSHelp80
	cmp D[pDExplore], 0
	je >>

	invoke SetCollection,[pDExplore],offset Collection

	invoke ShowTopic,[pDExplore],offset Keyword

	invoke Sleep, 2000

	invoke ShowTopic,[pDExplore],"ExitProcess"

	invoke WaitForClose

	invoke ReleaseInterface,[pDExplore]

	:
	invoke CoUninitialize
	invoke ExitProcess,0

WaitForClose FRAME
	LOCAL hwnd:D
	LOCAL pid:D
	LOCAL tid:D
	LOCAL hThread:D

	invoke FindWindow, DExploreWndClass, NULL
	mov [hwnd],eax

	:
	invoke Sleep,125
	invoke IsWindowVisible,[hwnd]
	test eax,eax
	jnz <

	RET
ENDF

GetInterface FRAME pInterface,ProgId, pIID
	LOCAL wszProgID[1024]:W
;	LOCAL pInterface:D
	LOCAL clsid	:GUID

	mov ecx,[pInterface]
	mov D[ecx],0

	invoke MultiByteToWideChar,CP_ACP,NULL,[ProgId],-1,offset wszProgID,1024
	// Get our Class ID
	invoke CLSIDFromProgID,offset wszProgID, offset clsid
	// Create an instance
	invoke CoCreateInstance,offset clsid, NULL, CLSCTX_ALL,[pIID], [pInterface]
	test eax,eax
	jnz >>.NOINSTANCE
	mov ecx,1
	RET

	.NOINSTANCE
	mov eax,0
	RET
ENDF

ReleaseInterface FRAME pInterface

	CoInvoke(pInterface,IVSHelp80.IUnknown.Release)

	RET

ENDF

SetCollection FRAME pInterface,pCollection
	LOCAL wszCollection[1024]:W
	LOCAL pbstrCollection:D
	LOCAL pbstrNULL:D

	invoke MultiByteToWideChar,CP_ACP,NULL,[pCollection],-1,offset wszCollection,1024

	invoke SysAllocString,offset wszCollection
	mov [pbstrCollection],eax

	invoke SysAllocString,offset wszNULL
	mov [pbstrNULL],eax

	//SetCollection
	CoInvoke(pInterface,IVSHelp80.Help.SetCollection,[pbstrCollection],[pbstrNULL])
	invoke SysFreeString,[pbstrCollection]
	invoke SysFreeString,[pbstrNULL]

	mov eax,[pInterface]
	RET
ENDF

SyncTopic FRAME pInterface, szTopic
	LOCAL wszTopic[1024]:W
	LOCAL pbstrTopic:D

	invoke MultiByteToWideChar,CP_ACP,NULL,[szTopic],-1,offset wszTopic,1024
	invoke SysAllocString,offset wszTopic
	mov [pbstrTopic],eax

	CoInvoke(pInterface,IVSHelp80.Help.SyncIndex,[pbstrTopic],1)
	CoInvoke(pInterface,IVSHelp80.Help.Index)

	invoke SysFreeString,[pbstrTopic]
	RET
ENDF

SearchForTopic FRAME pInterface, szTopic
	LOCAL wszTopic[1024]:W
	LOCAL pbstrTopic:D
	LOCAL pbstrNULL:D

	invoke SysAllocString,offset wszNULL
	mov [pbstrNULL],eax

	invoke MultiByteToWideChar,CP_ACP,NULL,[szTopic],-1,offset wszTopic,1024
	invoke SysAllocString,offset wszTopic
	mov [pbstrTopic],eax

	CoInvoke(pInterface,IVSHelp80.Help2.SearchEx,[pbstrNULL],[pbstrTopic],vsSearchFlagsExecuteSearch)

	invoke SysFreeString,[pbstrTopic]
	invoke SysFreeString,[pbstrNULL]
	
	mov eax,[pInterface]
	RET
ENDF

ShowTopic FRAME pInterface, szTopic
	LOCAL wszTopic[1024]:W
	LOCAL pbstrTopic:D

	invoke MultiByteToWideChar,CP_ACP,NULL,[szTopic],-1,offset wszTopic,1024
	invoke SysAllocString,offset wszTopic
	mov [pbstrTopic],eax

	CoInvoke(pInterface,IVSHelp80.Help.DisplayTopicFromKeyword,[pbstrTopic])
	CoInvoke(pInterface,IVSHelp80.Help.SyncIndex,[pbstrTopic],TRUE)

	invoke SysFreeString,[pbstrTopic]
	mov eax,[pInterface]
	RET
ENDF

